ORG &9000

;Test Kukulcan
;Utilisation de l'mulateur CapriceForever et du module PASMO ASSEMBLER

tailleraster1		EQU 200

XOR A
CALL &BC0E
CALL remplir_overscan
CALL OUT_OVERSCAN
CALL LESRASTERS
RET


;------------------------------------------------------------------------------
; LES RASTERS 
;------------------------------------------------------------------------------
LESRASTERS
CALL &BB00

	DI		; Desactiver les interruptions
	LD HL,(&38) 	; Lire l'ancienne interruption
	LD (Sauver),HL 	; Sauvegarder la valeur 16 bits
	LD HL,&C9FB 	; Registre 16 bits EI (&FB) + RET (&C9)
	LD (&38),HL 	; Ecrire en &0038 et &0039 le contenu du registre HL
	;EI 		; Interruption autorisees

Programme
	;raster rotation vers le bas
	LD A,(Raster1+tailleraster1-1)
	LD HL,Raster1+tailleraster1-2
	LD DE,Raster1+tailleraster1-1
	LD BC,tailleraster1-1
	LDDR
	LD (Raster1),A


	LD B,&F5 	; Se connecter au PPI/8255 port B accessible via &F5xx
Balayage
	IN A,(C) 	; Lire le contenu
	RRA 		; On teste si le bit 0 = 1
	JP nc,Balayage 	; Si le bit 0 = 0 on boucle jusqu'a la fin du balayage
			; On est en haut de l'ecran, on peut continuer le programme

	; Position vertical (141 coin haut gauche)
	;+8 pour ligne graphique suivante
	;+64 pour ligne texte suivante
	LD BC,141+64+64+8+8+6
WaitLoop21
	NOP		; 1 nop
	DEC BC		; 2 nops
	LD A,B		; 1 nop
	OR C		; 1 nops
	JR NZ,WaitLoop21; 3 nops, TOTAL 8 nops


	LD B,&7F 	; On selection le Gate Array          - 2 nops
	LD HL,Raster 	; HL pointe sur la table de couleurs  - 
BoucleRaster
	LD a,(hl) 	; On charge la couleur dans A
	CP &00 		; Si A=0 alors
	JP z,Touche 	; Saute au test clavier

	LD C,1		;                                     - 2 nops
	OUT (C),C 	; Selection encre 1                   - 4 nops
	OUT (C),A 	; Ecrire la couleur

	INC HL 		; Couleur suivante dans le tableau
	DS 42 		; Attendre fin de ligne
	JP BoucleRaster


; Test touche
Touche
	LD BC,&F40E
	OUT (C),C
	LD BC,&F6C0
	OUT (C),C
	XOR A
	OUT (C),A
	LD BC,&F792
	OUT (C),C
	LD BC,&F645	;ligne 5
	OUT (C),C
	LD B,&F4
	IN A,(C)
	LD BC,&F782
	OUT (C),C
	LD BC,&F600
	OUT (C),C
	RLA		;Charge dans A la valeur du bit 7 (touche ESPACE)
JR NC,Sortir
	LD BC,&F40E
	OUT (C),C
	LD BC,&F6C0
	OUT (C),C
	XOR A
	OUT (C),A
	LD BC,&F792
	OUT (C),C
	LD BC,&F649	;ligne 9
	OUT (C),C
	LD B,&F4
	IN A,(C)
	LD BC,&F782
	OUT (C),C
	LD BC,&F600
	OUT (C),C
	RLA		;Charge dans A la valeur du bit 7 (touche DEL)
	RLA		;Charge dans A la valeur du bit 6 (touche JOY_FIRE0)
	RLA		;Charge dans A la valeur du bit 5 (touche JOY_FIRE1 Z)
	RLA		;Charge dans A la valeur du bit 4 (touche JOY_FIRE2 X)
	JP C,Programme	;Si TIR du joystick n'a pas etait enfonce on boucle

Sortir
	;retour au BASIC
	DI 		; Desactiver les interruptions
	LD HL,(Sauver) 	; Restauration des anciennes interruptions
	LD (&38),hl 	; Ecrire
	EI 		; Interruption autorisees
	RET

Sauver
	DW #0000

Raster
;00 = &54 noir
;01 = &44 bleu
;02 = &55 bleu vif
;03 = &5C rouge fonce
;04 = &58 magenta
;05 = &5D mauve
;06 = &4C rouge vif
;07 = &45 pourpre
;08 = &4D magenta vif
;09 = &56 vert
;10 = &46 turquoise
;11 = &57 bleu ciel
;12 = &5E jaune
;13 = &40 gris
;14 = &5F bleu pastel
;15 = &4E orange
;16 = &47 rose
;17 = &4F magenta pastel
;18 = &52 vert vif
;19 = &42 vert marin
;20 = &53 turquoise vif
;21 = &5A vert citron
;22 = &59 vert pastel
;23 = &5B turquoise pastel
;24 = &4A jaune vif
;25 = &43 jaune pastel
;26 = &4B blanc

DB &4B ; mon encre 1

Raster1

;raster 8x25=200
DB &54,&44,&54,&44,&58,&54,&44,&58
DB &5D,&54,&44,&58,&5D,&5F,&54,&44
DB &58,&5D,&5F,&53,&4B,&54,&44,&58
DB &5D,&5F,&53,&5F,&53,&4B,&53,&4B
DB &4B,&43,&4B,&43,&4F,&43,&4F,&47
DB &58,&5C,&54,&4B,&43,&4F,&47,&58
DB &5C,&54,&4F,&47,&58,&5C,&54,&47
DB &58,&5C,&54,&58,&5C,&54,&5C,&5C
DB &54,&5C,&5E,&54,&5C,&5E,&45,&54
DB &5C,&5E,&45,&4F,&54,&5C,&5E,&45
DB &4F,&43,&4B,&54,&5C,&5E,&45,&4F
DB &43,&4F,&43,&4B,&43,&4B,&4B,&43
DB &4B,&43,&59,&43,&59,&5D,&58,&44
DB &54,&4B,&43,&59,&5D,&58,&44,&54
DB &59,&5D,&58,&44,&54,&5D,&58,&54
DB &44,&54,&44,&5D,&54,&44,&5D,&5F
DB &54,&44,&5D,&5F,&5B,&54,&44,&5D
DB &5F,&5B,&4B,&5B,&54,&5B,&4B,&5B
DB &5F,&5D,&44,&54,&5B,&5F,&5D,&44
DB &54,&5F,&5D,&44,&54,&5D,&44,&54
DB &44,&54,&5C,&54,&5C,&4C,&54,&5C
DB &4C,&47,&54,&5C,&4C,&47,&43,&54
DB &5C,&4C,&47,&43,&4B,&43,&47,&4C
DB &5C,&54,&43,&47,&4C,&5C,&54,&47
DB &4C,&5C,&54,&4C,&5C,&54,&5C,&54

DB &4B ; mon encre 1

DB 0 ;fin

;------------------------------------------------------------------------------
; REMPLIR OVERSCAN encre 1
;------------------------------------------------------------------------------
remplir_overscan
	LD HL,&200
	LD DE,&201
	LD BC,&7CFF
	LD (HL),&C0
	LDIR
	RET

;------------------------------------------------------------------------------
; OUT overscan
;------------------------------------------------------------------------------
OUT_OVERSCAN
;largeur
LD BC,&BC01
OUT (C),C
LD BC,&BD30
OUT (C),C

;hauteur
LD BC,&BC06
OUT (C),C
LD BC,&BD22
OUT (C),C

;decalage horizontal
LD BC,&BC02
OUT (C),C
LD BC,&BD32
OUT (C),C

;decalage vertical
LD BC,&BC07
OUT (C),C
LD BC,&BD23
OUT (C),C

;ecran 32 ko (&0000 a &7FFF)
LD BC,&BC0C
OUT (C),C
LD BC,&BD0D
OUT (C),C

;debut offset (en &0200)
LD BC,&BC0D
OUT (C),C
LD BC,&BD00
OUT (C),C
RET