//  This file is part of CPCtelera: An Amstrad CPC Game Engine
//  Copyright (C) 2020 Arnaud Bouche (@Arnaud6128)
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU Lesser General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU Lesser General Public License for more details.
//
//  You should have received a copy of the GNU Lesser General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//------------------------------------------------------------------------------
#include <cpctelera.h>

#ifdef WINCPCTELERA
	extern u16 wincpct_getCpcMemAddress(void* address);
	extern u8* wincpct_getPCMemPtr(u16 address);
	extern void wincpct_computeCrossBoundary(u16* videoAddress, u8 cx);

	void asm_drawSpriteClipped(u16 width_to_draw, void* sprite, u8 width, u8 height, void* memory)
	{
		u16 videoAddress = wincpct_getCpcMemAddress(memory);

		u8* src = (u8*)sprite;

		for (int i = 0; i < height; i++)
		{				
			u8* ptrVideo = wincpct_getPCMemPtr(videoAddress);
			cpct_drawSprite(src, ptrVideo, (u8)width_to_draw, 1);
			
			src += width;
			videoAddress += width;

			wincpct_computeCrossBoundary(&videoAddress, width);
		}
	}
#endif