//  This file is part of CPCtelera: An Amstrad CPC Game Engine
//  Copyright (C) 2020 Arnaud Bouche (@Arnaud6128)
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU Lesser General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU Lesser General Public License for more details.
//
//  You should have received a copy of the GNU Lesser General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//------------------------------------------------------------------------------
#include <cpctelera.h>

#ifdef WINCPCTELERA
/*****************************************************/
/*													 */
/*	Sprite Left shift of one pixel					 */
/*	From cpctelera example move1pixel				 */
/*												     */
/*****************************************************/
void asm_shiftSpritePixelsLeft(u8* sprite, u8 size)
{
	u8* next_byte = sprite + 1;

	while (--size)
	{
		*sprite = ((*sprite & 0b01010101) << 1) | ((*(next_byte) & 0b10101010) >> 1);
		sprite++;
		next_byte++;
	}

	*sprite = (*sprite & 0b01010101) << 1;
}

/*****************************************************/
/*													 */
/*	Sprite Right shift of one pixel				     */
/*	From cpctelera example move1pixel				 */
/*												     */
/*****************************************************/
void asm_shiftSpritePixelsRight(u8* sprite, u8 size)
{
	u8 prev_rightpixel = 0;

	do
	{
		u8 rightpixel = *sprite & 0b01010101;
		*sprite = (prev_rightpixel << 1) | ((*sprite & 0b10101010) >> 1);
		prev_rightpixel = rightpixel;
		sprite++;
	} 
	while (--size);
}
#endif