;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of CPCtelera: An Amstrad CPC Game Engine
;;  Copyright (C) 2018 Arnaud Bouche (@Arnaud6128)
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------
.module assembly

;;void asm_copySpriteClipped(u16 width_to_draw, u8 width, u8 height, void *source, void* destination) __z88dk_callee;
_asm_copySpriteClipped::
   ;; Get Parameters from the stack 
   pop  hl     ;; [3] HL = Return address   
   pop  bc     ;; [3] B = 0 / C = Sprite width to Drawn
   ld   b, #00 ;; [2]
   pop  de     ;; [3] DE = Height/Width (D = Height, E = Width)
   
   ld   a, c                       ;; [1] A = Sprite width to Drawn
   ld   (spriteClipped_width), a   ;; [4] Set Sprite Width to Draw at placeholder  
   sub  e                          ;; [1] A = Negative Sprite Offset (Sprite Width to Draw (A) - Sprite Width (E))
   neg                             ;; [1] A = -A
   ld   (spriteClipped_offset), a  ;; [4] Set Sprite Offset at placeholder  
   ld   a, d                       ;; [1] A = D (Height)
   
   pop  de      ;; [3] DE = Source Address (Data array)
   ex  (sp), hl ;; [6] HL = Buffer Destination Address, leaving previous HL value (return address)
   
;; Draw Sprite Clipped  
spriteClipped_height_loop:
   ex   de, hl     ;; [1] HL and DE are exchanged every line to do 16-bits maths with DE        
 
;; Placeholder for the Sprite Width to Draw   
spriteClipped_width = .+1     
   ld   c, #00     ;; [2] BC = Sprite Width to Draw 0 is default value
   ldir            ;; [5] Copy Sprite (DE++) = (HL++) -> BC--
   dec  a          ;; [1] Height--
   ret  z          ;; [2/3] If 0, we have finished the last sprite line.
   							
;; Placeholder for the Sprite Offset
spriteClipped_offset = .+1      
   ld   c, #00      ;; [2] BC = Sprite Offset 0 is default value
   add  hl, bc      ;; [3] Add offset Dest Sprite    
   ex   de, hl      ;; [1] DE has destination, but we have to exchange it with HL to be able to do 16-bits maths
   add  hl, bc      ;; [3] Add offset Src Sprite  
   jp   spriteClipped_height_loop   ;; [3] Jump to continue with next pixel line