;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of CPCtelera: An Amstrad CPC Game Engine
;;  Copyright (C) 2020 Arnaud Bouche (@Arnaud6128)
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------
.module game

;;void asm_copySpriteBufferPartial(u16 width_to_draw, u8 width, u8 height, u8* destination, u8* source) __z88dk_callee;
_asm_copySpriteBufferPartial::
   ;; Get Parameters from the stack 
   pop  hl        ;; [3] HL = Return address   
   pop  de        ;; [3] D = Nothing / E = width_sprite_to_draw
   ld   a, e      ;; [1] A = E (width_sprite_to_draw)
   pop  bc        ;; [3] BC = Height/Width (B = Height, C = Width)
   
   ld   (spriteClipped_width), a   ;; [4] Set Sprite Width to Draw at placeholder  
   sub  c                          ;; [1] A = Negative Sprite Offset (Sprite Width to Draw (A) - Sprite Width (C))
   neg                             ;; [1] A = -A
   ld   (spriteClipped_offset), a  ;; [4] Set Sprite Offset at placeholder  
   ld   a, b                       ;; [1] A = B (Height)
   ld   b, #00                     ;; [2] B = 0
   
   pop  de        ;; [3] DE = Destination address (Data array)
   ex  (sp), hl   ;; [6] HL = Source pointer (Video mem) <-> (SP) Returning back address because __z88dk_callee convention  

;; Draw Sprite Clipped  
spritePartial_height_loop:     
 
;; Placeholder for the Sprite Width to Draw   
spriteClipped_width = .+1     
   ld   c, #00    ;; [2] BC = Sprite Width to Draw 0 is default value
   ldir           ;; [5] Copy Sprite (DE++) = (HL++) -> BC--
   dec  a         ;; [1] Height--
   ret  z         ;; [2/3] If 0, we have finished the last sprite line.
   							
;; Placeholder for the Sprite Offset
spriteClipped_offset = .+1      
   ld   c, #00    ;; [2] BC = Sprite Offset 0 is default value
   add  hl, bc    ;; [3] Add offset Destination Sprite    
   jp   spritePartial_height_loop   ;; [3] Jump to continue with next pixel line