//-----------------------------LICENSE NOTICE------------------------------------
//  This file is part of CPCtelera: An Amstrad CPC Game Engine
//  Copyright (C) 2018 ronaldo / Fremos / Cheesetea / ByteRealms (@FranGallegoBR)
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU Lesser General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU Lesser General Public License for more details.
//
//  You should have received a copy of the GNU Lesser General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//------------------------------------------------------------------------------

/** CPCTelera includes */
#include <cpctelera.h>
#include "./wincpctelera/wincpctelera_helper.h"

/** Structures includes */
#include "./structures/structures.h"

/** Game includes */
#include "./tools/tools.h"
#include "./sprites/functions/packedSprites.h"
#include "./initialize/initialize.h"
#include "./initialize/interrupt.h"
#include "./video/video.h"
#include "./player/player.h"
#include "./player/playerMove.h"
#include "./room/room.h"
#include "./world/world.h"
#include "./room/roomDrawForest.h"
#include "./ui/uiboard.h"

/** Player Global */
u8 gPlayerRoomY;
SCoord gPlayerPos;
SPlayer gPlayer;

/** Game global */
BOOL gAdventure;
u8 gColorSky;
u8 gCrowBarSolidity;
u8 gLighterUses;
STorch gTorchHand;

/** Timer */
u8 gTimer;

/** Version */
const char VERSION[] = "V0810";

/** Main */
void main(void) 
{
    WinCpcTelera_PrintHex("TEMP_LOC_START", TEMP_LOC_START);
    WinCpcTelera_PrintHex("PLAYER_LOC_START", PLAYER_LOC);
    WinCpcTelera_PrintHex("WORLD_LOC_COMPRESS", WORLD_LOC_COMPRESS);
    WinCpcTelera_PrintHex("WORLD_LOC", WORLD_LOC);
    WinCpcTelera_PrintHex("WORLD_STATIC_LOC", WORLD_STATIC_LOC);
    WinCpcTelera_PrintHex("GRAPHICS_LOC", GRAPHICS_LOC);

    Initialize();

    while (TRUE)
    {		
        UpdatePlayer();	
        UpdateRoom();

        gTimer++;
    }
}
