//-----------------------------LICENSE NOTICE------------------------------------
//  This file is part of Throne Legacy
//  Copyright (C) 2020 Arnaud Bouche (@Arnaud6128)
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU Lesser General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU Lesser General Public License for more details.
//
//  You should have received a copy of the GNU Lesser General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//------------------------------------------------------------------------------

/** CPCTelera includes */
#include <cpctelera.h>

/** Structures includes */
#include "../structures/structures.h"

/** Decors Sprites */
#include "../sprites/allSprites.h"

/** Player includes */
#include "../player/player.h"
#include "../player/playerDraw.h"

/** Video includes */
#include "../video/video.h"
#include "../sprites/functions/packedSprites.h"

/** Game includes */
#include "../tools/tools.h"

/** Extern variables */
extern u8 gRoomId;

/** Global variables */
u8 gTempoMonster;

/*****************************************************/
/*													 */
/*	Draw monster eyes in dark		  				 */
/*												     */
/*****************************************************/
void DrawMonsterEyes()
{
    #define SPEED_DAMAGES   32

    if (gRoomId > DEMON_AREA && gRoomId != TO_CHAPEL_ROOM)
    {
        u8* vmem = GetScreenPlayer();
        DrawMirrorPackedSpriteMasked(G_EYES_INDEX, vmem, EYES_W, EYES_H);

        if (ModuloPowerTwo(gTempoMonster++, SPEED_DAMAGES) == 0)
            UpdateLife(-DEMON_DAMAGES);

        cpct_waitVSYNC();
    }
}