//-----------------------------LICENSE NOTICE------------------------------------
//  This file is part of Throne Legacy
//  Copyright (C) 2020 Arnaud Bouche (@Arnaud6128)
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU Lesser General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU Lesser General Public License for more details.
//
//  You should have received a copy of the GNU Lesser General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//------------------------------------------------------------------------------

/** Input filter */
#define GET_DIR(X)			(X & (TOP|DOWN|LEFT|RIGHT))
#define HAS_MOVE_X_AXIS(X)	((X & (LEFT|RIGHT)) != 0)
#define HAS_MOVE_Y_AXIS(Y)	((Y & (TOP|DOWN)) != 0)
#define HAS_LEFT(X)			((X & LEFT) != 0)
#define HAS_RIGHT(X)		((X & RIGHT) != 0)
#define HAS_TOP(X)			((X & TOP) != 0)
#define HAS_DOWN(X)			((X & DOWN) != 0)
#define HAS_FIRE(X)			((X & FIRE) != 0)
#define IS_FIRE(X)			(X == FIRE)
#define IS_SELECT(X)		(X == SELECT)
#define IS_FIRE_TOP(X)		((X & (TOP|FIRE)) == (TOP|FIRE))
#define IS_FIRE_DOWN(X)		((X & (DOWN|FIRE)) == (DOWN|FIRE))
#define IS_FIRE_LAT(X)		(((X & (FIRE|LEFT)) == (FIRE|LEFT)) || ((X & (FIRE|RIGHT)) == (FIRE|RIGHT)))

/** Move filter */
#define HAS_CROUCHING(X)	((X & (CROUCH_DOWN|CROUCH_UP)) != 0)
#define HAS_WALKING(X)		((X & (WALK|CHANGE_DIR)) != 0)
#define HAS_JUMPING(X)		((X & (LONG_JUMP|HIGH_JUMP)) != 0)

/** Move constants */
#define STOP_MOVE			255
#define NB_STEP_X			4
#define NB_STEP_Y			15
#define NB_STEP_CROUCH		2
#define WAIT_CHANGE_DIR		2
#define NB_STEP_JUMP_HIGH	(NB_STEP_X*2 + 10)
#define NB_STEP_JUMP_LONG	(NB_STEP_X*2 + 2)
#define MAX_STEP_LATT		(u8)8
#define MAX_STEP_FRONT		(u8)6

#define NO_COLLIDE			0
#define COLLIDE_ITEM		1
#define COLLIDE_ROOM		2

/** Mode constants */
#define MODE_MOVE			0
#define MODE_INV			1
#define MODE_STORE			2

void InitPlayer();
void SetRoomPosY();
void SetPlayerDir(u8 dir);
void SetMovePlayer(u8 move);
void SetupPlayerSpriteMove();
void SetPlayerPosition(u8 doorId);
void UpdatePlayerMove();
void SavePlayerPos();
void RestorePlayerPos();

u8 ConverDirToPos(u8 dir);
u8 CanExitDir(u8 dir);
u8 GetPlayerMovement();
u8 GetPlayerDir();
u8 GetLimitOfRoom(u8 dir);

BOOL IsFrontTopWall();