//-----------------------------LICENSE NOTICE------------------------------------
//  This file is part of Throne Legacy
//  Copyright (C) 2020 Arnaud Bouche (@Arnaud6128)
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU Lesser General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU Lesser General Public License for more details.
//
//  You should have received a copy of the GNU Lesser General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//------------------------------------------------------------------------------

/** External resources */

/** Room parts */
#include "./external/latt_frame.h"
#include "./external/front_frame.h"
#include "./external/down_frame.h"
#include "./external/stone_angle.h"
#include "./external/stone_wall.h"
#include "./external/stone_wall_2.h"
#include "./external/latt_stone_wall.h"
#include "./external/torch_wall.h"
#include "./external/wall_crack.h"
#include "./external/latt_wall.h"
#include "./external/front_door_wood.h"
#include "./external/front_door_empty.h"
#include "./external/latt_door_wood.h"
#include "./external/latt_ground.h"
#include "./external/ground.h"
#include "./external/ground_far.h"
#include "./external/fireplace.h"
#include "./external/table.h"
#include "./external/taprestry_f.h"
#include "./external/taprestry_l.h"
#include "./external/window_f.h"
#include "./external/window_l.h"
#include "./external/trap.h"
#include "./external/trap_hidden.h"
#include "./external/paint_frame.h"
#include "./external/paints.h"
#include "./external/pit.h"
#include "./external/pit_wall.h"
#include "./external/front_door_secret.h"
#include "./external/chest.h"
#include "./external/chest_close.h"
#include "./external/chest_open.h"
#include "./external/stair_up.h"
#include "./external/stair_down.h"
#include "./external/web.h"
#include "./external/grid_door.h"
#include "./external/skeleton.h"
#include "./external/shields.h"
#include "./external/altar.h"
#include "./external/circle.h"
#include "./external/demon.h"
#include "./external/skull.h"
#include "./external/chains.h"
#include "./external/eyes.h"
#include "./external/eyes_moving.h"
#include "./external/beam.h"
#include "./external/beam_border.h"
#include "./external/sign.h"

/** UI */
#include "./external/number.h"
#include "./external/board.h"
#include "./external/ui_select.h"
#include "./external/ui_select_large.h"
#include "./external/chest_ui.h"
#include "./external/ui_selection.h"
#include "./external/shop_gradient.h"

/** Room forest */
#include "./external/bush.h"
#include "./external/ground_forest.h"
#include "./external/herb.h"
#include "./external/castle.h"
#include "./external/tower.h"
#include "./external/entrance.h"
#include "./external/lac_forest.h"

/** Item in rooom */
#include "./external/objects.h"

/** Sprite player */
#include "./local/front_head.h"
#include "./local/front_legs.h"
#include "./local/top_front_legs.h"
#include "./local/front_chest.h"
#include "./local/front_high_jump.h"
#include "./local/latt_head.h"
#include "./local/latt_legs.h"
#include "./local/latt_chest.h"
#include "./local/latt_high_jump.h"
#include "./local/long_jump.h"
#include "./local/hand_empty.h"
#include "./local/hand_torch.h"

/** Sprite objet player */
#include "./local/pied_biche.h"
#include "./local/potion.h"
#include "./local/rope.h"
#include "./local/keys.h"

/** Sprites not compressed */
#include "./local/calice_filled.h"
#include "./local/ui_flame.h"
#include "./local/flames.h"
#include "./local/wall_line.h"
#include "./local/secret_key_hole.h"
#include "./local/fonts.h"