//-----------------------------LICENSE NOTICE------------------------------------
//  This file is part of Throne Legacy
//  Copyright (C) 2020 Arnaud Bouche (@Arnaud6128)
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU Lesser General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU Lesser General Public License for more details.
//
//  You should have received a copy of the GNU Lesser General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//------------------------------------------------------------------------------

#pragma once

#include "defines.h"

// Action definitions
enum
{
    NO_MOVE,
    TOP = 0x01,
    DOWN = 0x02,
    LEFT = 0x04,
    RIGHT = 0x08,
    SELECT = 0x10,
    FIRE = 0x20,
    SUICIDE = 0x30
};

enum
{
    FALL_PIT = 0x40,
    CLIMB_UP_PIT,
    CLIMB_DOWN_PIT,
    EXIT_DOOR,
    EXIT_WALL,
    EXIT_ALL,
    EXIT_DOOR_CLOSED
};

#define MOVE_FILTER	0x0F

// Move definitions
enum
{
    WALK = 0x01,
    LONG_JUMP = 0x02,
    HIGH_JUMP = 0x04,
    CROUCH_DOWN = 0x08,
    CROUCH_UP = 0x10,
    CHANGE_DIR = 0x20
};

// Boolean definition
#define BOOL		u8
#define TRUE		1
#define FALSE		0

typedef struct 
{
    u8 x, y;
    u8 dir;
} SPos;

typedef struct
{
    u8 x;
    u8 y;
} SCoord;

typedef struct
{
    u8 x, cx;
} SWidth;
