//-----------------------------LICENSE NOTICE------------------------------------
//  This file is part of Throne Legacy
//  Copyright (C) 2020 Arnaud Bouche (@Arnaud6128)
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU Lesser General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU Lesser General Public License for more details.
//
//  You should have received a copy of the GNU Lesser General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//------------------------------------------------------------------------------

/** CPCTelera includes */
#include <cpctelera.h>

/** Game include */
#include "fontsHelper.h"
#include "../Tools/tools.h"

/** Text resources */
#include "textResources.h"

// To be generated in DEBUG

/*static const u8 _texts[] =
    "_LONG LIVE THE KING\0"\
    "_DEAD\0"\
    "_NIGHT IS FALLING\0"\
    "_IT'S DARK HERE\0"\
    "_GROUND FLOOR\0"\
    "_BASEMENT\0"\
    "_FIRST FLOOR\0"\
    "_LAST FLOOR\0"\
    "_OUTDOORS\0"\
    "_IT'S CLOSED\0"\
    "_IT'S OPENED\0"\
    "_WRONG KEY\0"\
    "_THE LOCK RESISTS\0"\
    "_CROWBAR BREAKS\0"\
    "_INVENTORY IS FULL\0"\
    "_PERSIA\0"\
    "_LAKE OF SPIRITS\0"\
    "_KING'S CELL\0"\
    "_CUP OF SOULS\0"\
    "_YOU MUST BE CROUCHING\0"\
    "_THE CUP IS FILLED\0"\
    "_THE DEMON IS GONE\0"\
    "_TORCH EXTINGUISHES\0"\
    "_TORCHES ON THE WALL CAN BE REPLACED\0"\
    "_DEMONS FLEE WATER OF THE SOULS\0"\
    "_THERE'S SOMETHING IN THE DARK\0"\
    "_TORCH\0"\
    "_LIGHTER\0"\
    "_ROPE\0"\
    "_CROWBAR\0"\
    "_POTION\0";

void SaveText()
{
    FILE* fileText = NULL;
    fopen_s(&fileText, "../resources/text/text.dat", "wb");
    if (fileText != NULL)
    {
        fwrite(_texts, sizeof(_texts), 1, fileText);
        fclose(fileText);
    }
}*/

/*****************************************************/
/*													 */
/*	Print text resource id							 */
/*												     */
/*****************************************************/
void PrintTextId(u8 id)
{
   // SaveText();

    u8 static sPrevId = 0;
    if (id != sPrevId)
    {
        u8* text = Decompress(G_text);
        u8 findId = 0;

        sPrevId = id;

        while (1)
        {
            if (*text == '_')
            {
                if (findId++ == id)
                {
                    PrintText(text + 1);
                    return;
                }
            }

            text++;
        }
    }
}