//-----------------------------LICENSE NOTICE------------------------------------
//  This file is part of Throne Legacy
//  Copyright (C) 2020 Arnaud Bouche (@Arnaud6128)
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU Lesser General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU Lesser General Public License for more details.
//
//  You should have received a copy of the GNU Lesser General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//------------------------------------------------------------------------------

#define IsInRange(value, min, max)	(value >= min && value <= max)
#define GetRand()					cpct_getRandom_xsp40_u8()
#define GetRandBool()				(cpct_getRandom_xsp40_u8() & 1)
#define ModuloPowerTwo(X, D)		(X & (D - 1))

#ifndef WINCPCTELERA
	#define START_BENCH	__asm\
	ld bc, #0x7F10\
	out(c), c\
	ld c, #76\
	out(c), c\
	__endasm;

	#define END_BENCH	__asm\
	ld bc, #0x7F10\
	out(c), c\
	ld c, #84\
	out(c), c\
	__endasm;
#else
	#define START_BENCH
	#define END_BENCH
#endif

typedef void(*TInterrupt)(void);
void SetInterruptHandler(TInterrupt interruptFunction);

void SetDefaultTempLocation();
void SetTempLocation(u8* mem);
u8* Decompress(const u8* data);

void SetRandSeed(u8 value);
u8 GetRandMax(u8 max);
u8 GetRandMaxTwo();

