//-----------------------------LICENSE NOTICE------------------------------------
//  This file is part of Throne Legacy
//  Copyright (C) 2020 Arnaud Bouche (@Arnaud6128)
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU Lesser General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU Lesser General Public License for more details.
//
//  You should have received a copy of the GNU Lesser General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//------------------------------------------------------------------------------

#include "../structures/memMapping.h"

// Screen size
#define SCREEN_CX		80
#define SCREEN_CY		200

#define BACKGROUND_BYTE		(u8)(cpctm_px2byteM0(COLOR_BACKGROUND, COLOR_BACKGROUND))
#define COLOR_BLACK_BYTE	(u8)(cpctm_px2byteM0(COLOR_BLACK, COLOR_BLACK))

#define	COLOR_YELLOW		00
#define	COLOR_TRANSPARENT	COLOR_YELLOW
#define	COLOR_BLACK			01
#define	COLOR_BACKGROUND	COLOR_BLACK
#define	COLOR_BLUE			02
#define	COLOR_BRIGHT_BLUE	03
#define	COLOR_SKY_BLUE		04
#define	COLOR_RED			05
#define	COLOR_BRIGHT_RED	06
#define	COLOR_PURPLE		07
#define	COLOR_ORANGE		08
#define	COLOR_PINK			09
#define	COLOR_GREEN			10
#define	COLOR_BRIGHT_GREEN	11
#define	COLOR_BRIGHT_YELLOW	12
#define	COLOR_BRIGHT_CYAN	13
#define	COLOR_WHITE			14
#define	COLOR_BRIGHT_WHITE	15

//  Declare mask table
cpctm_declareMaskTable(gMaskTable);

void FlipAndShiftSprite(u8* sprite, u8 width, u8 height, u8 shift);
u8* GetScreenPtr(u8 xPos, u8 yPos);
u8* GetDecompressSpriteFlip(u8* data, u8 cx, u8 cy, BOOL flip);

void DrawMirrorCompressedSpriteMasked(u8* data, u8* vmem, u8 cx, u8 cy);
void DrawCompressedSprite(u8* data, u8* vmem, u8 cx, u8 cy, BOOL flip);
void DrawCompressedSpriteMasked(u8* data, u8* vmem, u8 cx, u8 cy, BOOL flip);
void DrawSpriteMasked(u8* sprite, u8* vmem, u8 cx, u8 cy);
                                    