//-----------------------------LICENSE NOTICE------------------------------------
//  This file is part of Throne Legacy
//  Copyright (C) 2020 Arnaud Bouche (@Arnaud6128)
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU Lesser General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU Lesser General Public License for more details.
//
//  You should have received a copy of the GNU Lesser General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//------------------------------------------------------------------------------

#pragma once

#define MAX_ROOMS					64		
#define	MAX_CHEST					7
#define MAX_ROOMS_ITEMS             20

typedef struct 
{
    SRoom rooms[MAX_ROOMS];
    SChest chests[MAX_CHEST];
    SItemsRoom roomsItems[MAX_ROOMS_ITEMS];
}SWorld;

typedef struct
{
    SRoomStatic roomsStatic[MAX_ROOMS];
}SWorldStatic;

void InitWorld();
void ResetWorld();
void LoadWorld();

SRoom* GetRoom(u8 roomId);
SItemsRoom* GetRoomItems(u8 roomId);
SChest* GetRoomChest();

u16 GetObjectSpriteId(u8 objectId);

BOOL HaveDoor(u8 door);
BOOL IsGameWin();